package apap.tutorial.belajarbelajar.controller;

import apap.tutorial.belajarbelajar.model.RoleModel;
import apap.tutorial.belajarbelajar.model.UserModel;
import apap.tutorial.belajarbelajar.repository.UserDb;
import apap.tutorial.belajarbelajar.service.RoleService;
import apap.tutorial.belajarbelajar.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Controller
@RequestMapping("/user")
public class UserController {
    @Autowired
    private UserService userService;

    @Autowired
    private RoleService roleService;

    @Autowired
    private UserDb userDb;

    @GetMapping(value = "/add")
    private String addUserFormPage(Model model){
        UserModel user = new UserModel();
        List<RoleModel> listRole = roleService.findAll();
        model.addAttribute("user", user);
        model.addAttribute("listRole", listRole);
        return "form-add-user";
    }

    @PostMapping(value = "/add")
    private String addUserSubmit(@ModelAttribute UserModel user, Model model){
        user.setIsSso(false);
        userService.addUser(user);
        model.addAttribute("user", user);
        return "redirect:/";
    }

    @GetMapping(value = "/viewall")
    private String viewAllUser(Model model){
        List<UserModel> listUser = userService.getListUser();
        model.addAttribute("listUser", listUser);
        return "viewall-user";
    }

    @GetMapping(value ="/delete/{username}")
    public String deleteUserByUsername(@PathVariable String username, Model model){
        UserModel user = userService.getUserByUsername(username);
        userService.deleteUser(user);
        model.addAttribute("user", user);
        return "delete-user";
    }

    @GetMapping(value = "/ubah-password")
    public String ubahPasswordForm(){
        return "form-ubah-password";
    }

    @PostMapping(value = "/ubah-password")
    public String ubahPasswordSubmit(
            @RequestParam("passwordLama") String passwordLama,
            @RequestParam("passwordBaru") String passwordBaru,
            @RequestParam("passwordKonfirmasi") String passwordKonfirmasi,
            Model model
    ){
        Authentication auth = SecurityContextHolder.getContext().getAuthentication();
        UserModel user = userDb.findByUsername(auth.getName());
        String response = userService.updatePassword(user, passwordLama, passwordBaru, passwordKonfirmasi);
        model.addAttribute("response", response);
        return "ubah-password-berhasil";
    }
}
