package apap.tutorial.belajarbelajar.service;

import apap.tutorial.belajarbelajar.model.UserModel;
import apap.tutorial.belajarbelajar.repository.UserDb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class UserServiceImpl implements UserService{
    @Autowired
    private UserDb userDb;

    @Override
    public UserModel addUser(UserModel user){
        String pass = encrypt(user.getPassword());
        user.setPassword(pass);
        return userDb.save(user);
    }

    @Override
    public String encrypt(String password){
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        String hashedPassword = passwordEncoder.encode(password);
        return hashedPassword;
    }

    @Override
    public UserModel getUserByUsername(String username){
        return userDb.findByUsername(username);
    }

    @Override
    public List<UserModel> getListUser(){
        return userDb.findAll();
    }

    @Override
    public UserModel getUserById(String id){
        Optional<UserModel> user = userDb.findById(Long.valueOf(id));
        if (user.isPresent()){
            return user.get();
        } else return null;
    }

    @Override
    public UserModel deleteUser(UserModel user){
        userDb.delete(user);
        return user;

    }

    @Override
    public String updatePassword(UserModel user, String pwLama, String pwBaru, String pwKonfirmasi){
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        boolean isMatch = passwordEncoder.matches(pwLama, user.getPassword());
        if (isMatch && pwBaru.equals(pwKonfirmasi) || (isMatch != pwBaru.equals(pwKonfirmasi))){
            user.setPassword(passwordEncoder.encode(pwBaru));
            userDb.save(user);
            return "Password berhasil diubah";
        } else if (isMatch == false){
            return "Password lama Anda tidak sesuai";
        } else if (pwBaru.equals(pwKonfirmasi) == false){
            return "Password salah, silakan konfirmasi ulang password Anda";
        } else if (pwLama.equals(pwBaru)){
            return "Password baru Anda sama dengan password lama Anda, silakan input ulang";
        } else {
            return "";
        }
    }
}
